
/* For use of MAXUSORT for MAXIMUS CBCS 2.00  */

#define MAXFILE         9
#define MAXEXT          4

/* internal sort record */
struct   _ust
    {
      unsigned short int rcd;          // relative user record number
      unsigned short int lrp;          // users lastread offset
      unsigned long  int val;          // user 'value'
      };                               // (zero for archived user)

struct month
    {
       char   m_name[4];                // name of the month
       int    m_days ;                  // its number of days
       } montab[] = { {"Jan",31}, {"Feb",28}, {"Mar",31},
                      {"Apr",30}, {"May",31}, {"Jun",30},
                      {"Jul",31}, {"Aug",31}, {"Sep",30},
                      {"Oct",31}, {"Nov",30}, {"Dec",31} };

/* READ-ONLY global variables */

char *privil[] = {"Twit","","Disgrace","Limited",
                  "Normal", "Worthy","Privil","Favored","Extra",
                  "Clerk","Assist-Sysop","CoSysop","Sysop","Hidden"};

char PROGNAME[] = "MAXUSORT";           // program name
char PROGDESC[] = "MAXIMUS CBCS User-SORT and Archive utility, OS/2+DOS";
char VERSION    = 1;                    // version
char SUBVERS    = 0;                    // sub-version
char SUFFIX     = ' ';                  // development suffix
char AUTHOR[]   = "Rob Hamerling";      // program author

char ufn[]     = "USER.BBS";            // input (becomes USER.BAK)
char bfn[]     = "USER.BAK";            // output (becomes USER.BBS)
char tfn[]     = "USER.TMP";            // intermediate
char rfn[]     = "USER.RMV";            // archived users
char lfn[]     = "LASTREAD.BBS";        // lastread file in each msgarea
char afn[]     = "AREA.DAT";            // contains paths to msg-area's
char MAX[]     = "MAXIMUS CBCS";        // Supported Bulletin Board Program


/* READ/WRITE global variables */

int    n = 0;                           // number of users in USER.BBS
int    r_del;                           // <rmv> user count
int    o_lastread = 0;                  //  0 do not update lastread pointers
                                        // >0 reset lastread pointers to zero
                                        // note: lastread pointers of archived
                                        //      users are always reset to zero


/* ========== function prototypes =========== */

int          calc_days(char *);
void         check_parm(int, char *[]);
int          comp_user(struct _ust *, struct _ust *);
int          create_user(struct _ust *);
void         display_banner(void);
void         display_help(void);
void         last_read(struct _ust *);
void         last_zero(struct _ust *, char *);
int          num_parm(char *, int, int *);
FILE        *print_user(int, FILE *, unsigned int, struct _usr *);
struct _ust *read_user(void);
void         stamp_rmv(void);
int          swap_user(void);


